
library(psych)

dat <- read.csv("C:/folder/filename.csv")  # Read in data.  This assumes it's 
                                           # raw itemwise data (dichotomous or 
                                           # ordinal) with no ID column.

factors <- 3   # How many factors do you want to extract?

Threshold <- 0.15    # Threshold to use when creating target from pattern matrix

###############################################################
# Begin rotation sequence 
###############################################################

x <- dat

n.obs <- dim(x)[1]

TT <- 0.5 - Threshold

xcor <- polychoric(x)$rho

items <- dim(xcor)[1]

r1 <- fa(xcor,factors)

t0 <- round(abs(r1$loadings) + TT,0)

targ0 <- list(as.numeric(matrix(gsub(1,NA,t0),items,factors)))

first <- matrix(targ0,1,items)

tr1 <- fa(xcor,factors,rotate="TargetQ",Target=targ0,maxit=50000)

targ <- round(abs(tr1$loadings) + TT,0)

targ <- list(as.numeric(matrix(gsub(1,NA,targ),items,factors)))

TargetList <- rbind(matrix(unlist(first),1,items*factors),matrix(unlist(targ),1,items*factors))

repeat {

sol <- fa(xcor,factors,rotate="TargetQ",Target=targ,maxit=50000)

targ <- round(abs(sol$loadings) + TT,0)

targ <- list(as.numeric(matrix(gsub(1,NA,targ),items,factors)))

TargetList <- rbind(TargetList,matrix(unlist(targ),1,items*factors))

if (dim(TargetList)[1] != dim(unique(TargetList))[1]) break }

fa.sort(sol)  

# This is the output. To see how many iterations were necessary to get there, 
# type TargetList.  The number of rows of that is the number of iterations, 
# where the first row is iteration 0.

